//$Id: AuthorityDaoHibernate.java,v 1.3 2007/01/13 07:06:51 chaostone Exp $
/*
 *
 * Copyright c 2005-2009
 * Licensed under the Apache License, Version 2.0 (the "License")
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 */
/********************************************************************************
 * @author chaostone
 * 
 * MODIFICATION DESCRIPTION
 * 
 * Name                 Date                Description 
 * ============         ============        ============
 * chaostone             2005-9-27         Created
 *  
 ********************************************************************************/

package org.beangle.security.internal.dao;

import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.beangle.model.persist.impl.AbstractBaseDao;
import org.beangle.model.query.EntityQuery;
import org.beangle.security.Authority;
import org.beangle.security.Group;
import org.beangle.security.Resource;
import org.beangle.security.dao.AuthorityDao;

public class AuthorityDaoImpl extends AbstractBaseDao implements
		AuthorityDao {

	public Authority getAuthority(Group group, Resource resource) {
		Map params = new HashMap();
		params.put("group", group);
		params.put("resource", resource);
		List authorityList = entityDao.searchNamedQuery(
				"getGroupAuthorityByResource", params, false);
		if (authorityList.isEmpty())
			return null;
		else
			return (Authority) authorityList.get(0);
	}

	public List getAuthorities(Group group) {
		Map params = new HashMap();
		params.put("groupId", group.getId());
		return entityDao.searchNamedQuery("getAuthorities", params, false);
	}

	/**
	 * 查询用户组对应的模块
	 */
	public List getResources(Group group) {
		String hql = "select distinct m from Group as r join r.authorities as a"
				+ " join a.resource as m where  r.id = :groupId and m.enabled = true";
		EntityQuery query = new EntityQuery(hql);
		query.setParameter("groupId", group.getId()).setCacheable(true);
		return entityDao.search(query);
	}

	/**
	 * 找到该组内激活的资源id
	 */
	public Set getResourceIds(Group group) {
		String hql = "select m.id from Group as r join r.authorities as a"
				+ " join a.resource as m where  r.id = :groupId and m.enabled = true";
		EntityQuery query = new EntityQuery(hql);
		query.setParameter("groupId", group.getId()).setCacheable(true);
		return new HashSet(entityDao.search(query));
	}

	public void saveOrUpdate(Authority authority) {
		entityDao.saveOrUpdate(authority);
	}

	public void remove(Authority authority) {
		entityDao.remove(authority);
	}

}
