//$Id: GroupDaoHibernate.java,v 1.1 2006/10/12 14:39:58 chaostone Exp $
/*
 *
 * Copyright c 2005-2009
 * Licensed under the Apache License, Version 2.0 (the "License")
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 */
/********************************************************************************
 * @author chaostone
 * 
 * MODIFICATION DESCRIPTION
 * 
 * Name                 Date                Description 
 * ============         ============        ============
 * dell                 2005-8-31           Created
 * chaostone            2005-9-26           move,add
 *  
 ********************************************************************************/

package org.beangle.security.internal.dao;

import java.util.List;

import org.beangle.model.persist.impl.AbstractBaseDao;
import org.beangle.model.query.Condition;
import org.beangle.model.query.EntityQuery;
import org.beangle.security.Group;
import org.beangle.security.dao.GroupDao;

/**
 * 用户组信息存取实现类
 * 
 * @author dell, chaostone 2005-9-26
 */
public class GroupDaoImpl extends AbstractBaseDao implements GroupDao {

	public void remove(Group group) {
		entityDao.remove(group);
	}

	public void remove(Long groupId) {
		Group group = (Group) entityDao.get(Group.class, groupId);
		entityDao.remove(group);
	}

	public List get(Long[] groupIds) {
		EntityQuery query = new EntityQuery(Group.class, "g");
		query.add(new Condition("g.id in(:gids)", groupIds));
		return entityDao.search(query);
	}

	public Group get(Long groupId) {
		return (Group) entityDao.get("Group", groupId);
	}

	public void saveOrUpdate(Group group) {
		entityDao.saveOrUpdate(group);
	}

}
