//$Id: UserDaoHibernate.java,v 1.2 2006/12/05 08:31:32 chaostone Exp $
/*
 *
 * Copyright c 2005-2009
 * Licensed under the Apache License, Version 2.0 (the "License")
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 */
/********************************************************************************
 * @author chaostone
 * 
 * MODIFICATION DESCRIPTION
 * 
 * Name                 Date                Description 
 * ============         ============        ============
 * dell                 2005-8-31           Created
 * chaostone            2005-9-26           modified
 *  
 ********************************************************************************/

package org.beangle.security.internal.dao;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.beangle.model.persist.impl.AbstractBaseDao;
import org.beangle.model.query.EntityQuery;
import org.beangle.security.User;
import org.beangle.security.dao.UserDao;

/**
 * 系统用户信息存取实现类
 * 
 * @author dell,chaostone 2005-9-26
 */
public class UserDaoImpl extends AbstractBaseDao implements UserDao {

	public User get(String name, String password) {
		Map params = new HashMap();
		params.put("name", name);
		params.put("password", password);
		List userList = entityDao.searchNamedQuery("userLogin", params);
		if (userList.size() > 0)
			return (User) userList.get(0);
		else
			return null;
	}

	public User get(Long userId) {
		return (User) entityDao.get("User", userId);
	}

	public List get(Long[] userIds) {
		String hql = "from User where id in(:ids)";
		EntityQuery query = new EntityQuery(hql);
		query.setParameter("ids", userIds);
		return entityDao.search(query);
	}

	public void remove(User user) {
		entityDao.remove(user);
	}

	public void remove(Long userId) {
		entityDao.remove(get(userId));
	}

	public void saveOrUpdate(User user) {
		entityDao.saveOrUpdate(user);
	}

	public void remove(Long[] ids) {
		for (int i = 0; i < ids.length; i++) {
			remove(ids[i]);
		}
	}

}
